(in-package "BLUDISTE")

(provide "generovani")

(require "mapa" "mapa")



(defmethod generovani((jmeno_souboru_vstup string)

                      (jmeno_souboru_vystup string)

                      (pocet_klicu integer)

                      (pocet_strel integer)

                      (pocet_priser integer))

  (let* ((vstup (open jmeno_souboru_vstup :direction :input))

         (spousteni (progn (read vstup) (read vstup) (read vstup) (read vstup)

                     (read vstup) (read vstup) (read vstup) (read vstup) (read vstup)))

         (pole (nth 3 (nth 3 (nth 1 spousteni))))

         (postava (nth 1 (nth 5 (nth 1 spousteni))))

         (postava_x (nth 3 (nth 3 postava)))

         (postava_y (nth 5 (nth 3 postava)))

         (postava_pozice (make-instance 'trida_pozice :x postava_x :y postava_y))

         (prisery (nth 7 (nth 1 spousteni)))

         (mapa (make-instance 'trida_mapa :pole pole))

         (vystup (open jmeno_souboru_vystup :direction :output 

                       :if-exists :supersede

                       :if-does-not-exist :create

                       ))

         (nove_prisery (generuj_prisery mapa pocet_priser postava_pozice))

       )

    (close vstup)



    (setq mapa (generuj_klice mapa pocet_klicu postava_pozice))

    (setq mapa (generuj_strely mapa pocet_strel postava_pozice))



    (generovani_hlavicky vystup)



    (format vystup "    :mapa (make-instance 'trida_mapa :pole~%")

    (zapis_mapu mapa vystup)

    (format vystup ")~%")



    (format vystup "    :postavy (list~%")

    (format vystup "      (make-instance 'trida_postava~%")

    (format vystup "        :pozice (make-instance 'trida_pozice :x ~A :y ~A)~%" postava_x postava_y)

    (format vystup "        :smer_pohledu 'nahoru~%")

    (format vystup "        :tahovy_objekt (make-instance priklad_trida_tahovy_objekt_postava)~%")

    (format vystup "        :pocet_strel 3~%")

    (format vystup "        :pocet_zivotu 3~%")

    (format vystup "      )~%")

    (format vystup "    )~%")





    (format vystup "    :prisery (list~%")



    (cond ((null nove_prisery)

             (mapc #'(lambda(cislo_prisery)

                       (let* ((prisera (nth (+ 1 cislo_prisery) prisery))

                              (prisera_trida (nth 1 (nth 1 prisera)))

                              (prisera_x (nth 3 (nth 3 prisera)))

                              (prisera_y (nth 5 (nth 3 prisera)))

                             )

                         (format vystup "      (make-instance '~A~%" (string-downcase prisera_trida))

                         (format vystup "        :pozice (make-instance 'trida_pozice :x ~A :y ~A))~%" 

                                 prisera_x prisera_y)

                       )

                     )

                   (cisla (- (length prisery) 1))

             )

          )

          (t

             (mapc #'(lambda(prisera)

                       (let* ((prisera_trida 'trida_prisera_nahodne)

                              (prisera_x (slot_x prisera))

                              (prisera_y (slot_y prisera))

                             )

                         (format vystup "      (make-instance '~A~%" (string-downcase prisera_trida))

                         (format vystup "        :pozice (make-instance 'trida_pozice :x ~A :y ~A))~%" 

                                 prisera_x prisera_y)

                       )

                     )

                   nove_prisery

             )

          )

    )         



    (format vystup "    )~%")



    (generovani_konce vystup)

    (close vystup)

    mapa

  )

)



(defun generovani_hlavicky(vystup)

  (format vystup "(in-package \"BLUDISTE\")~%")

  (format vystup "(require \"hra\" \"hra\")~%")

  (format vystup "(require \"mapa\" \"mapa\")~%")

  (format vystup ";(require \"tah_graficky\" \"tah_graficky\")~%")

  (format vystup ";(require \"tah_textove\" \"tah_textove\")~%")

  (format vystup "(require \"tah_nahodne\" \"tah_nahodne\")~%")

  (format vystup "(require \"prisera\" \"prisera\")~%")

  (format vystup "(require \"monitor_graficky\" \"monitor_graficky\")~%")

  (format vystup ";(require \"monitor_textove\" \"monitor_textove\")~%")

  (format vystup "~%")

  (format vystup ";(setq priklad_trida_tahovy_objekt_postava 'trida_tahovy_objekt_postava_graficky)~%")

  (format vystup ";(setq priklad_trida_tahovy_objekt_postava 'trida_tahovy_objekt_postava_textove)~%")

  (format vystup "(setq priklad_trida_tahovy_objekt_postava 'trida_tahovy_objekt_postava_nahodne)~%")

  (format vystup "(setq priklad_trida_monitor 'trida_monitor_graficky)~%")

  (format vystup ";(setq priklad_trida_monitor 'trida_monitor_textove)~%")

  (format vystup "~%")

  (format vystup "(spustit~%")

  (format vystup "  (make-instance 'trida_hra~%")

)



(defun generovani_konce(vystup)

  (format vystup "    :monitory (list (make-instance priklad_trida_monitor))~%")

  (format vystup "  )~%")

  (format vystup ")~%")

)



;(in-package "BLUDISTE")

;(generovani "bludiste1.lsp" "bludiste1_2.lsp" 100 100 0)

;(generovani "bludiste2.lsp" "bludiste2_2.lsp" 96 96 0)

;(generovani "bludiste3.lsp" "bludiste3_2.lsp" 32 32 0)

;(generovani "bludiste4.lsp" "bludiste4_2.lsp" 32 32 0)

;(generovani "bludiste5.lsp" "bludiste5_2.lsp" 44 44 0)

;(generovani "bludiste6.lsp" "bludiste6_2.lsp" 30 30 0)

;(generovani "bludiste7.lsp" "bludiste7_2.lsp" 160 160 0)

;(generovani "bludiste8.lsp" "bludiste8_2.lsp" 100 100 0)

;(generovani "bludiste9.lsp" "bludiste9_2.lsp" 100 100 100)

;(generovani "bludiste10.lsp" "bludiste10_2.lsp" 100 100 100)

;(generovani "bludiste11.lsp" "bludiste11_2.lsp" 50 50 50)

;(generovani "bludiste12.lsp" "bludiste12_2.lsp" 50 50 50)

;(generovani "bludiste13.lsp" "bludiste13_2.lsp" 32 32 32)

;(generovani "bludiste14.lsp" "bludiste14_2.lsp" 32 32 32)

