(in-package "BLUDISTE")

(provide "graficke_rozhrani")

(require "legenda" "legenda")





; --------------------------------------------------------------

; graficke rozhrani ke hre

; ========================





(capi:define-interface interface_zaklad ()

  (

   (hra :type trida_hra :initarg :hra :accessor slot_hra)

   (velikost :type integer :initarg :velikost :accessor slot_velikost

             :initform 10)

   (prekreslovani :type function :initarg :prekreslovani)

  )

  (:panes 

     (mapa capi:output-pane :display-callback prekreslovani

           :horizontal-scroll t

           :vertical-scroll t

           :scroll-width (+ 1 (* velikost (sirka (slot_mapa hra))))

           :scroll-height (+ 1 (* velikost (vyska (slot_mapa hra))))

           :visible-min-width '(min (* :screen-width 3/4)

                                    :scroll-width)

           :visible-min-height '(min (* :screen-height 3/4)

                                     :scroll-height)

     )

     (cislo_tahu capi:title-pane :title "Cislo tahu:"

                 :text (format nil "~D" 0))

     (max_tahu capi:title-pane :title "Max tahu:"

               :text (format nil "~D" 0))

  )

  (:layouts

     (sloupec capi:column-layout

        '(radek_tahu radek_mapa)

     )

     (radek_mapa capi:row-layout

        '(mapa)

     )

     (radek_tahu capi:row-layout

        '(cislo_tahu max_tahu)

     )

  )

  (:menus

     (menu-legenda "Legenda" (("Legenda" :selection-callback 'zobraz_legendu)

                            ))

  )

  (:menu-bar menu-legenda)

)





(capi:define-interface interface_bludiste (interface_zaklad)

  ()

  (:panes )

  (:layouts )

  (:default-initargs :title "Bludiste" 

                     :prekreslovani #'nakresli_mapu

                     :velikost 10

  )

)





(defun button_action (data interface)

  (setf (slot_provedeny_tah interface) data)

)





(capi:define-interface interface_postavicka (interface_zaklad)

  ((postava :type trida_postava :initarg :postava :accessor slot_postava)

   (provedeny_tah :type symbol :accessor slot_provedeny_tah)

  )

  (:panes

     (pocet_zivotu capi:title-pane :title "Zivotu:"

                   :text (format nil "~D" 0))

     (pocet_klicu capi:title-pane :title "Klicu:"

                  :text (format nil "~D" 0))

     (pocet_strel capi:title-pane :title "Strel:"

                  :text (format nil "~D" 0))

     (pocet_bodu capi:title-pane :title "Bodu:"

                 :text (format nil "~D" 0))

     (tah-stop capi:push-button :image "posun_stop2.bmp"

               :data 'stop :callback 'button_action)

     (tah-dopredu capi:push-button :image "posun_dopredu2.bmp"

                  :data 'dopredu :callback 'button_action)

     (tah-dozadu capi:push-button :image "posun_dozadu2.bmp"

                 :data 'dozadu :callback 'button_action)

     (tah-doleva capi:push-button :image "posun_doleva2.bmp"

                 :data 'doleva :callback 'button_action)

     (tah-doprava capi:push-button :image "posun_doprava2.bmp"

                  :data 'doprava :callback 'button_action)

     (tah-otoc-doleva capi:push-button :image "otocit_doleva.bmp"

                      :data 'otoc_doleva :callback 'button_action)

     (tah-otoc-doprava capi:push-button :image "otocit_doprava.bmp"

                       :data 'otoc_doprava :callback 'button_action)

     (tah-otoc-dozadu capi:push-button :image "otocit_dozadu.bmp"

                      :data 'otoc_dozadu :callback 'button_action)

     (tah-strela capi:push-button :image "strela.bmp"

                 :data 'strela :callback 'button_action)

     (tah-bumerang capi:push-button :image "bumerang.bmp"

                   :data 'bumerang :callback 'button_action)

  )

  (:layouts

     (sloupec capi:column-layout

        '(radek_tahu radek_pocty radek_mapa radek-tahy)

        :visible-max-width t

        :visible-max-height t

     )

     (radek_pocty capi:row-layout

        '(pocet_zivotu pocet_klicu pocet_strel pocet_bodu)

     )

     (tahy-posun capi:grid-layout

        '(nil tah-dopredu nil

          tah-doleva tah-stop tah-doprava

          nil tah-dozadu nil)

        :columns 3

        :rows 3

        :x-adjust '(:right :center :left)

        :y-adjust '(:bottom :center :top)

     )

     (tahy-otaceni-strany capi:row-layout

        '(tah-otoc-doleva tah-otoc-doprava)

        :y-adjust :center

     )

     (tahy-otaceni capi:column-layout

        '(tahy-otaceni-strany tah-otoc-dozadu)

        :x-adjust :center

     )

     (tahy-strely capi:column-layout

        '(tah-strela tah-bumerang)

        :x-adjust :center

     )

     (radek-tahy capi:row-layout

        '(nil tahy-posun nil tahy-otaceni nil tahy-strely nil)

        :y-adjust :center

     )

  )

  (:menus

     (menu-posun "Posun" (("Dopredu" :data 'dopredu

                                     :selection-callback 'button_action)

                           ("Dozadu" :data 'dozadu

                                     :selection-callback 'button_action)

                           ("Doprava" :data 'doprava

                                     :selection-callback 'button_action)

                           ("Doleva" :data 'doleva

                                     :selection-callback 'button_action)

                           ("Stop" :data 'stop

                                   :selection-callback 'button_action)

                          ))

     (menu-otoceni "Otoceni" (("Doprava" :data 'otoc_doprava

                                       :selection-callback 'button_action)

                              ("Doleva" :data 'otoc_doleva

                                        :selection-callback 'button_action)

                              ("Dozadu" :data 'otoc_dozadu

                                        :selection-callback 'button_action)

                             ))

     (menu-strela "Strela" (("Strela" :data 'strela

                                      :selection-callback 'button_action)

                            ("Bumerang" :data 'bumerang

                                      :selection-callback 'button_action)

                            ))

  )

  (:menu-bar menu-posun menu-otoceni menu-strela menu-legenda)

  (:default-initargs :title "Postavicka"

                     :prekreslovani #'nakresli_viditelnou_mapu

                     :velikost 15)

)

