(in-package "BLUDISTE")

(provide "log_viewer")
(require "hra" "hra")


(defclass trida_log_viewer (trida_hra)
  (
   (log_postavy :type list :accessor slot_log_postavy :initarg :log_postavy)
   (log_prisery :type list :accessor slot_log_prisery :initarg :log_prisery)
   (log_strely :type list :accessor slot_log_strely :initarg :log_strely)
  )
)

(defmethod hra_init((hra trida_log_viewer))
  (pro_monitory hra
    #'(lambda (monitor) (setf (slot_hra monitor) hra))
  )
  (setf (slot_konec hra) nil)

  (let ((nove_postavy (vytvor_z_logu 'trida_postava (slot_log_postavy hra) 1))
        (nove_prisery (vytvor_z_logu 'trida_prisera (slot_log_prisery hra) 1))
        (nove_strely (vytvor_z_logu 'trida_strela (slot_log_strely hra) 1))
       )
    (setf (slot_postavy hra) nove_postavy)
    (setf (slot_prisery hra) nove_prisery)
    (setf (slot_strely hra) nove_strely)
  )
)

(defun vytvor_z_logu(trida log cislo_tahu)
  (mapcan #'(lambda(log_jedne)
              (cond ((numberp (car log_jedne))
                       (cond ((eql cislo_tahu (car log_jedne))
                                (list (make-instance trida :log (cdr log_jedne)))
                             )
                             (t nil)
                       )
                    )   
                    (t (list (make-instance trida :log log_jedne)))
              )
            )
          log
  )
)

(defmethod proved_jeden_tah ((hra trida_log_viewer))
  (cond ((not (hra_zvetsit_cislo_tahu hra))
    (nastav_konec_hry hra "PREKROCEN MAXIMALNI POCET TAHU")
  ))
  (cond ((slot_konec hra) nil)
        (t
         (pro_strely hra #'(lambda(strela) 
                             (test_odstranit_log_strelu hra strela)))
         (pro_prisery hra #'(lambda(strela) 
                             (test_odstranit_log_priseru hra strela)))
         (let ((nove_strely (vytvor_z_logu 'trida_strela (slot_log_strely hra)
                                          (slot_cislo_tahu hra))))
           (setf (slot_strely hra) (nconc (slot_strely hra) nove_strely))
         )
         (tah_vsechny hra (slot_strely hra) #'kontrola_tahu_strela)
         (tah_vsechny hra (slot_prisery hra) #'kontrola_tahu_prisera)
         (pro_vsechny hra #'krok)
         (mp:process-wait-with-timeout "" 2)
         (tah_vsechny hra (slot_postavy hra) #'kontrola_tahu_postava)
         (pro_vsechny hra #'krok)
         (mp:process-wait-with-timeout "" 2)
         (pro_postavy hra #'(lambda(postava) 
                             (test_konec_log hra postava)))
         (proved_jeden_tah hra)
        )
  )
)

(defmethod test_konec_log((hra trida_hra) (postava trida_postava))
  (cond 
    ((null (slot_log postava))
      (setf (slot_konec hra) "konec"))
  )
)

(defmethod test_odstranit_log_priseru((hra trida_hra) (prisera trida_prisera))
  (cond
    ((null (slot_log prisera))
      (odstranit_priseru hra prisera)
  ) )
)

(defmethod test_odstranit_log_strelu((hra trida_hra) (strela trida_strela))
  (cond
    ((null (slot_log strela))
      (odstranit_strelu hra strela)
  ) )
)

(defmethod tah_vsechny((hra trida_log_viewer) (aktivni_objekty list) 
                       (kontrola function))
  (mapc #'(lambda (aktivni_objekt)
             (stav_z_logu aktivni_objekt (slot_cislo_tahu hra))
          )
        aktivni_objekty
  )
)

(defmethod zapis_log((hra trida_log_viewer))
)