(in-package "BLUDISTE")

(provide "mapa")

(require "pozice" "pozice")



; --------------------------------------------------------------

; indexovani policek v mape

; =========================



(defclass trida_mapa() 

  (

    (pole :type simple-vector :accessor slot_pole :initarg :pole)

  )

)



(defmethod get_pole((mapa trida_mapa) (pozice trida_pozice))

  (let* ((pole (slot_pole mapa))

         (prvni_radek (aref pole 0))

         (x (slot_x pozice))

         (y (slot_y pozice))

        )

    (cond

      ((minusp x) 'zed)

      ((minusp y) 'zed)

      ((>= y (length pole)) 'zed)

      ((>= x (length prvni_radek)) 'zed)

      (t

        (let* ((radek (aref (slot_pole mapa) (slot_y pozice)))

               (policko (aref radek (slot_x pozice))))

           policko

;          (cond

;            ((null policko) 'zed)

;            (t policko)

;          )

        )

      )

    )

  )

)



(defmethod get_radek((mapa trida_mapa) (cislo_radku integer))

  (aref (slot_pole mapa) cislo_radku)

)



;nastavit stav policka na mape

(defmethod set_pole((mapa trida_mapa) (pozice trida_pozice) 

                    (hodnota symbol))

  (setf (aref (aref (slot_pole mapa) (slot_y pozice))

              (slot_x pozice)

        )

        hodnota

  )

)



(defmethod vyska((mapa trida_mapa))

  (length (slot_pole mapa))

)



(defmethod sirka((mapa trida_mapa))

  (length (aref (slot_pole mapa) 0))

)



(defmethod mapa_reverse((mapa trida_mapa))

  (make-instance 'trida_mapa :pole (reverse (slot_pole mapa)))

)



(defmethod generuj_klice((mapa trida_mapa) (pocet integer) (postava_pozice trida_pozice))

  (mapc #'(lambda(x) 

            (declare (ignore x))

            (generuj_jeden mapa 'klic postava_pozice)) 

        (cisla pocet)

  )

  mapa

)



(defmethod generuj_strely((mapa trida_mapa) (pocet integer) (postava_pozice trida_pozice))

  (mapc #'(lambda(x)

            (declare (ignore x))

            (generuj_jeden mapa 'strela postava_pozice)) 

        (cisla pocet)

  )

  mapa

)



(defmethod generuj_prisery((mapa trida_mapa) (pocet integer) (postava_pozice trida_pozice))

  (mapcar #'(lambda(x)

              (declare (ignore x))

              (generuj_jednu_priseru mapa postava_pozice)) 

          (cisla pocet)

  )

)



(defmethod test_vzdalenost3((postava_pozice trida_pozice) (novy_objekt_pozice trida_pozice))

  (and (<= (abs (- (slot_x novy_objekt_pozice) 

                   (slot_x postava_pozice))) 3)

       (<= (abs (- (slot_y novy_objekt_pozice)

                   (slot_y postava_pozice))) 3))

)



(defmethod generuj_jeden((mapa trida_mapa) (co symbol) (postava_pozice trida_pozice))

  (let* ((sirka (sirka mapa))

         (vyska (vyska mapa))

         (pozice_x (random sirka))

         (pozice_y (random vyska))

         (pozice (make-instance 'trida_pozice :x pozice_x :y pozice_y))

         (policko (get_pole mapa pozice))

        )

    (cond ((test_vzdalenost3 postava_pozice pozice) (generuj_jeden mapa co postava_pozice))

          ((eql policko 'chodba) 

             (set_pole mapa pozice co)

          )

          (t (generuj_jeden mapa co postava_pozice))

    )

  )

)



(defmethod generuj_jednu_priseru((mapa trida_mapa) (postava_pozice trida_pozice))

  (let* ((sirka (sirka mapa))

         (vyska (vyska mapa))

         (pozice_x (random sirka))

         (pozice_y (random vyska))

         (pozice (make-instance 'trida_pozice :x pozice_x :y pozice_y))

         (policko (get_pole mapa pozice))

        )

    (cond ((test_vzdalenost3 postava_pozice pozice) (generuj_jednu_priseru mapa postava_pozice))

          ((eql policko 'chodba) pozice)

          (t (generuj_jednu_priseru mapa postava_pozice))

    )

  )

)



(defmethod zapis_mapu((mapa trida_mapa) (vystup stream))

  (let ((prvni_sloupec t))

    (format vystup "      #(~%")

    (mapc #'(lambda(cislo_radku)

              (cond 

                    (t (format vystup "        "))

              )

              (format vystup "#(")

              (setq prvni_sloupec t)

              (mapc #'(lambda(cislo_sloupce)

                        (cond (prvni_sloupec (setq prvni_sloupec nil))

                              (t (format vystup " "))

                        )

                        (format vystup "~A" (string-downcase (get_pole mapa 

                           (make-instance 'trida_pozice :x cislo_sloupce :y cislo_radku))))

                      )

                    (cisla (sirka mapa))

              )

              (format vystup ")~%")

            )

          (cisla (vyska mapa))

    )

    (format vystup "      )")

  )

)

