(in-package "BLUDISTE")

(provide "monitor_graficky")

(require "monitor" "monitor")

(require "tisk_graficky" "tisk_graficky")

(require "graficke_rozhrani" "graficke_rozhrani")

(require "log_viewer" "log_viewer")



; ***** monitor pro graficke zobrazeni *****



(defclass trida_monitor_graficky(trida_monitor) 

  (

    (interface :type interface_bludiste :accessor slot_interface)

  )

)





(defmethod start((monitor trida_monitor_graficky))

  (setf (slot_interface monitor)

        (make-instance 'interface_bludiste

                       :hra (slot_hra monitor)

        )

  )

  (capi:display (slot_interface monitor))

)





(defmethod krok((monitor trida_monitor_graficky))

  (prekresli_mapu (slot_interface monitor))

)





(defmethod konec((monitor trida_monitor_graficky))

  (let ((hra (slot_hra monitor)))

    (capi:display-message "KONEC HRY!~%~A" (slot_konec hra))

    (zobraz_konec_body monitor)

    (capi:quit-interface (slot_interface monitor))

    (zapis_log hra)

  ) 

)



(defmethod zobraz_konec_body((monitor trida_monitor_graficky))

  (let ((hra (slot_hra monitor)))

    (cond ((typep hra 'trida_log_viewer) nil)

          (t

            (mapc

              #'(lambda (postava)

                (capi:display-message "bodu: ~A~%tahu: ~A~% cas:~A"

                  (slot_pocet_bodu postava)

                  (slot_cislo_tahu hra) 

                  (/ (slot_cislo_tahu hra) 

                     (max 1 (slot_pocet_bodu postava)))

              ) )

              (slot_postavy hra)

            )

          )

    )

  )

)

