(in-package "BLUDISTE")

(provide "pozice")

(require "konstanty" "konstanty")



; --------------------------------------------------------------

; pozice

; ======



(defclass trida_pozice() 

  (

    (x :type integer :accessor slot_x :initform 0 :initarg :x)

    (y :type integer :accessor slot_y :initform 0 :initarg :y)

  )

)



(defconstant vektor_stop (make-instance 'trida_pozice :x 0 :y 0))

(defconstant vektor_dolu (make-instance 'trida_pozice :x 0 :y -1))

(defconstant vektor_nahoru (make-instance 'trida_pozice :x 0 :y 1))

(defconstant vektor_doleva (make-instance 'trida_pozice :x -1 :y 0))

(defconstant vektor_doprava (make-instance 'trida_pozice :x 1 :y 0))

(defconstant vektor_nahoru_doprava (make-instance 'trida_pozice :x 1 :y 1))

(defconstant vektor_nahoru_doleva (make-instance 'trida_pozice :x -1 :y 1))

(defconstant vektor_dolu_doprava (make-instance 'trida_pozice :x 1 :y -1))

(defconstant vektor_dolu_doleva (make-instance 'trida_pozice :x -1 :y -1))



;nova pozice podle smeru

(defun nova_pozice_relativne(smer)

  (cond ((eql smer 'dopredu) vektor_nahoru)

        ((eql smer 'dozadu) vektor_dolu)

        ((eql smer 'doleva) vektor_doleva)

        ((eql smer 'doprava) vektor_doprava)

        (t vektor_stop)

  )

)



(defmethod posun((pozice trida_pozice) (kolik integer))

  (make-instance 'trida_pozice :x (+ (slot_x pozice) kolik)

                               :y (+ (slot_y pozice) kolik)

  )

)



(defmethod relativni_pozice_posunuta((relativni_pozice trida_pozice))

  (make-instance 'trida_pozice

                 :x (+ (slot_x relativni_pozice) max_viditelnost)

                 :y (- (slot_y relativni_pozice) 0))

)



(defmethod test_pulkruh((relativni_pozice trida_pozice))

  (let ((x (slot_x relativni_pozice))

        (y (slot_y relativni_pozice))

       )

    (> (+ 0.1 max_viditelnost) (sqrt (+ (* x x) (* y y))))

  )

)



(defmethod rozdil((pozice1 trida_pozice) (pozice2 trida_pozice))

  (make-instance 'trida_pozice

                 :x (- (slot_x pozice1) (slot_x pozice2))

                 :y (- (slot_y pozice1) (slot_y pozice2)))

)



(defmethod soucet((pozice1 trida_pozice) (pozice2 trida_pozice))

  (make-instance 'trida_pozice

                 :x (+ (slot_x pozice1) (slot_x pozice2))

                 :y (+ (slot_y pozice1) (slot_y pozice2)))

)



(defun matice_transformace_pohled(smer_pohledu)

  (cond ((eql smer_pohledu 'dolu) #2A((-1 0) (0 1)))

        ((eql smer_pohledu 'nahoru) #2A((1 0) (0 -1)))

        ((eql smer_pohledu 'doprava) #2A((0 1) (1 0)))

        ((eql smer_pohledu 'doleva) #2A((0 -1) (-1 0)))

  )

)



(defmethod transformace_pohled((globalni_pozice trida_pozice) smer_pohledu)

  (let* ((stare_x (slot_x globalni_pozice))

         (stare_y (slot_y globalni_pozice))

         (matice (matice_transformace_pohled smer_pohledu))

         (nove_x (+ (* stare_x (aref matice 0 0))

                    (* stare_y (aref matice 0 1))))

         (nove_y (+ (* stare_x (aref matice 1 0))

                    (* stare_y (aref matice 1 1))))

        )

    (make-instance 'trida_pozice :x nove_x :y nove_y)

  )

)



(defmethod rovnost((pozice1 trida_pozice) (pozice2 trida_pozice))

  (and (eql (slot_x pozice1) (slot_x pozice2))

       (eql (slot_y pozice1) (slot_y pozice2)))

)





(defmethod pozice_xy((pozice trida_pozice))

  (list (slot_x pozice) (slot_y pozice))

)

