(in-package "BLUDISTE")

(provide "provadeni_tahu")

(require "tah" "tah")

(require "aktivni_objekt" "aktivni_objekt")

(require "pozice" "pozice")

(require "hra" "hra")

(require "tahovy_objekt" "tahovy_objekt")



; --------------------------------------------------------------

; provadeni tahu

; ==============





;provedeni posunu postavou v danem smeru bez kontroly

(defmethod proved_posun((postava trida_aktivni_objekt) (smer symbol))

  (setf (slot_pozice postava) (nova_pozice postava smer))

)



;sebere klic nebo strelu

(defmethod proved_sbirani((hra trida_hra) (postava trida_aktivni_objekt))

  (let* ((pozice (slot_pozice postava))

         (stav_pole (get_pole (slot_mapa hra) pozice)))

    (cond ((typep postava 'trida_postava)

             (cond ((eql stav_pole 'klic)

                    (postava_pridat_klic postava)

                    (postava_pridat_bod postava)

                    (set_pole (slot_mapa hra) pozice 'chodba)

                   )

                   ((eql stav_pole 'strela)

                    (postava_pridat_strelu postava)

                    (set_pole (slot_mapa hra) pozice 'chodba)

                   )

             )

          )

    )

  )

)



;provede otoceni pohledu

(defun novy_pohled (pohled smer_otoceni)

 (let* ((smery '(nahoru doprava dolu doleva))

        (smery2 (append smery smery))

        (smery2r (reverse smery2))

       )

   (cond ((eql smer_otoceni 'otoc_doprava)

            (cadr (member pohled smery2)))

         ((eql smer_otoceni 'otoc_doleva)

            (cadr (member pohled smery2r)))

         ((eql smer_otoceni 'otoc_dozadu)

            (caddr (member pohled smery2)))

   )

 )

)



(defmethod proved_otoceni((postava trida_aktivni_objekt) 

                          (smer_otoceni symbol))

  (setf (slot_smer_pohledu postava)

        (novy_pohled (slot_smer_pohledu postava)

                     smer_otoceni))

)





;pridani nove strely do hry

(defmethod vytvor_strelu((hra trida_hra) 

                         (postava trida_aktivni_objekt) 

                         tahovy_objekt)

  (let* ((pozice (slot_pozice postava))

         (smer_pohledu (slot_smer_pohledu postava))

         (strela (make-instance 'trida_strela

           :pozice pozice

           :smer_pohledu smer_pohledu

           :tahovy_objekt (cond

             ((null tahovy_objekt) 

                (make-instance 'trida_tahovy_objekt_strela_dopredu))

             (t tahovy_objekt)

           )

           :pocet_zivotu max_dostrel

           :vlastnik postava

           :log (list (slot_cislo_tahu hra))))

        )

    (postava_odebrat_strelu postava)

    (pridat_strelu hra strela)

  )

)





; ***** provedeni tahu postavou *****



(defmethod proved_tah((hra trida_hra) 

                      (postava trida_aktivni_objekt) 

                      (tah trida_tah))

  (let ((akce (slot_akce tah))

        (tahovy_objekt (slot_tahovy_objekt tah))

       )

    (cond

      ((member akce '(dopredu dozadu doleva doprava))

        (proved_posun postava akce)

        (proved_sbirani hra postava)

      )

      ((member akce '(otoc_doprava otoc_doleva otoc_dozadu))

        (proved_otoceni postava akce)

      )

      ((eql akce 'strela)

        (cond ((plusp (slot_pocet_strel postava))

            (vytvor_strelu hra postava tahovy_objekt))

        )

      )

    )

  )

)

