(in-package "BLUDISTE")

(provide "smer")

(require "pozice" "pozice")



; --------------------------------------------------------------

; smer

; ====



(defmethod vektor_pohledu((smer_pohledu symbol))

  (cond ((eql smer_pohledu 'dolu) vektor_dolu)

        ((eql smer_pohledu 'nahoru) vektor_nahoru)

        ((eql smer_pohledu 'doleva) vektor_doleva)

        ((eql smer_pohledu 'doprava) vektor_doprava)

  )

)



(defmethod smer_pohledu_z_vektoru((vektor trida_pozice))

  (cond ((rovnost vektor vektor_dolu) 'dolu)

        ((rovnost vektor vektor_nahoru) 'nahoru)

        ((rovnost vektor vektor_doleva) 'doleva)

        ((rovnost vektor vektor_doprava) 'doprava)

  )

)



(defun konverze_smer(n)

  (cond ((eql n 0) 'stop)

        ((eql n 1) 'dopredu)

        ((eql n 2) 'dozadu)

        ((eql n 3) 'doleva)

        ((eql n 4) 'doprava)

  )

)



(defun konverze_smer_pohledu(n)

  (cond ((eql n 0) 'nahoru)

        ((eql n 1) 'dolu)

        ((eql n 2) 'doprava)

        ((eql n 3) 'doleva)

  )

)



(defun smer_nahodne()

   (konverze_smer (random 5))

)



(defun smer_pohledu_nahodne()

   (konverze_smer_pohledu (random 4))

)



(defun smer_pohledu_nahodne_vodorovne()

   (konverze_smer_pohledu (+ 2 (random 2)))

)



(defun smer_pohledu_nahodne_svisle()

   (konverze_smer_pohledu (random 2))

)



(defun smery_nahodne()

  (let ((smery '(stop dopredu dozadu doleva doprava))

        (nove_smery nil)

        (index1 (random 5))

        (index2 (random 4))

        (index3 (random 3))

        (index4 (random 2))

        (index5 0)

       )

    (setq nove_smery (cons (nth index1 smery) nove_smery))

    (setq smery (delete (car nove_smery) smery))

    (setq nove_smery (cons (nth index2 smery) nove_smery))

    (setq smery (delete (car nove_smery) smery))

    (setq nove_smery (cons (nth index3 smery) nove_smery))

    (setq smery (delete (car nove_smery) smery))

    (setq nove_smery (cons (nth index4 smery) nove_smery))

    (setq smery (delete (car nove_smery) smery))

    (setq nove_smery (cons (nth index5 smery) nove_smery))

    (setq smery (delete (car nove_smery) smery))

    (setq nove_smery (append nove_smery '(stop)))

    nove_smery

  )

)



(defun smer_nahodne_rovne()

  (let ((n (random 3)))

    (cond ((eql n 0) 'stop)

          ((eql n 1) 'dopredu)

          ((eql n 2) 'dozadu)

    )

  )

)



(defun vyber_smer(smery)

  (cond ((null (cdr smery)) (car smery))

        (t (let* ((delka (length smery))

                  (n (random (- delka 1)))

                  (smer (car (nthcdr n smery)))

                 )

              smer

           )

        )

  )

)



(defun inverzni_smer(smer)

  (cond ((eql smer 'dopredu) 'dozadu)

        ((eql smer 'dozadu) 'dopredu)

        ((eql smer 'doprava) 'doleva)

        ((eql smer 'doleva) 'doprava)

  )

)

