(in-package "BLUDISTE")

(provide "tah_graficky")

(require "tahovy_objekt" "tahovy_objekt")

(require "tisk_graficky" "tisk_graficky")



; --------------------------------------------------------------

; graficke zadavani tahu

; ======================



;nova trida obsahujici graficky interface

(defclass trida_tahovy_objekt_postava_graficky(trida_tahovy_objekt) 

  (

    (interface :type interface_postavicka :accessor slot_interface)

  )

)





(defmethod start((tahovy_objekt trida_tahovy_objekt_postava_graficky))

  (let* (

    (pomocna_hra (make-instance 'trida_hra

                                :mapa (prazdna_viditelna_mapa))

    )

    (interface (make-instance 'interface_postavicka

                              :hra pomocna_hra)

    )

  )

  (setf (slot_interface tahovy_objekt) interface)

  (capi:display interface)

))





(defmethod konec((tahovy_objekt trida_tahovy_objekt_postava_graficky))

  (capi:quit-interface (slot_interface tahovy_objekt))

)





;tahova funkce pouzivajici interface

(defmethod tahova_funkce((tahovy_objekt trida_tahovy_objekt_postava_graficky) 

                         (parametry trida_parametry_tahu))

  (let* ((pomocna_hra (make-instance 'trida_hra

           :mapa (mapa_reverse (slot_viditelna_mapa parametry))

           :postavy (list (make-instance 'trida_postava

                            :pozice (make-instance 'trida_pozice 

                                                   :x max_viditelnost 

                                                   :y max_viditelnost)

                            :smer_pohledu 'nahoru))

           :prisery (posun_viditelne_objekty 

                       (slot_viditelne_prisery parametry))

           :strely (posun_viditelne_objekty 

                      (slot_viditelne_strely parametry))

           :cislo_tahu (slot_cislo_tahu parametry)

           :maximum_tahu (slot_maximum_tahu parametry)

         ))

         (interface (slot_interface tahovy_objekt))

        )

    (setf (slot_hra interface) pomocna_hra)

    (setf (slot_postava interface) (slot_vlastni_postava parametry))

    (prekresli_viditelnou_mapu interface)

    (setf (slot_provedeny_tah interface) nil)

    (mp:process-wait "cekam na provedeni tahu"

                     (lambda(x) (not (null (slot_provedeny_tah x))))

                     interface)

    (let ((tah (slot_provedeny_tah interface)))

      (cond

        ((eql tah 'bumerang)

          (make-instance 'trida_tah :akce 'strela :tahovy_objekt 

             (make-instance 'trida_tahovy_objekt_strela_bumerang)))

        (t (make-instance 'trida_tah :akce tah))

      )

    )

  )

)

