(in-package "BLUDISTE")

(provide "tisk_textove")

(require "hra" "hra")

(require "pozice" "pozice")



; --------------------------------------------------------------

; tiskove funkce

; ==============



;tisk jednoho policka

(defmethod tisk_policka((pozice trida_pozice)

                        (hra trida_hra)

                        (postavy_radek list)

                        (prisery_radek list)

                        (strely_radek list))

  (let ((policko (get_pole (slot_mapa hra) pozice)))

    (cond ((test_aktivni_objekty_pozice pozice postavy_radek) (princ #\+))

          ((test_aktivni_objekty_pozice pozice prisery_radek) (princ #\-))

          ((test_aktivni_objekty_pozice pozice strely_radek) (princ #\%))

          ((eql policko 'zed) (princ #\X))

          ((eql policko 'chodba) (princ #\ ))

          ((eql policko 'vychod) (princ #\0))

          ((eql policko 'strela) (princ #\S))

          ((eql policko 'klic) (princ #\K))

          ((null policko) (princ #\.))

    )

  )

)



;tisk jednoho radku

(defmethod tisk_radku((cislo_radku integer) (hra trida_hra))

  (let ((postavy_radek (aktivni_objekty_na_radku cislo_radku

                                                 (slot_postavy hra)))

        (prisery_radek (aktivni_objekty_na_radku cislo_radku

                                                 (slot_prisery hra)))

        (strely_radek (aktivni_objekty_na_radku cislo_radku

                                                (slot_strely hra)))

       )

    (mapc (lambda (cislo_sloupce)

            (tisk_policka (make-instance 'trida_pozice 

                                         :x cislo_sloupce :y cislo_radku)

                          hra

                          postavy_radek

                          prisery_radek

                          strely_radek)

          )

          (cisla (sirka (slot_mapa hra)))

    )

  )

)



;tisk mapy

(defmethod tisk_mapy((hra trida_hra))

  (mapc #'(lambda (cislo_radku)

            (tisk_radku cislo_radku hra)

            (format t "~%")

          )

        (cisla (vyska (slot_mapa hra)))

  )

  nil

)



;obecne tisk pole

(defun tisk_pole(nazev pole)

  (format t "~A: ~%" nazev)

  (mapc #'(lambda (radek)

           (format t "~A~%" radek))

        pole

  )

)



(defun tisk(nazev hodnota)

  (format t "~A:   ~A~%" nazev hodnota)

)

