(in-package "BLUDISTE")

(provide "viditelna_mapa")

(require "konstanty" "konstanty")

(require "mapa" "mapa")

(require "aktivni_objekt" "aktivni_objekt")

(require "pozice" "pozice")



; --------------------------------------------------------------

; viditelnost v mape

; ==================





(defmethod hodnota_mapy((mapa trida_mapa) 

                        (aktivni_objekt trida_aktivni_objekt) 

                        (relativni_lokalni trida_pozice))

  (let* ((smer_pohledu (slot_smer_pohledu aktivni_objekt))

         (relativni_globalni

           (transformace_pohled relativni_lokalni smer_pohledu))

        )

    (get_pole mapa (soucet (slot_pozice aktivni_objekt)

                           relativni_globalni))

) )



(defmethod viditelna_mapa_test((viditelna_mapa trida_mapa) 

                               (relativni_pozice_posunuta trida_pozice)

                               (hodnota symbol)

                               (predchazejici_pole symbol))

  (cond ((null predchazejici_pole) nil)

        ((eql predchazejici_pole 'zed) nil)

        (t (set_pole viditelna_mapa relativni_pozice_posunuta hodnota))

  )

)



(defmethod viditelna_mapa_test2((viditelna_mapa trida_mapa) 

                                (relativni_pozice_posunuta trida_pozice)

                                (hodnota symbol)

                                (predchazejici_pole1 symbol)

                                (predchazejici_pole2 symbol)

                                (predchazejici_pole3 symbol))

  (cond ((null predchazejici_pole1) nil)

        ((eql predchazejici_pole1 'zed) nil)

        ((or (and (not (null predchazejici_pole2))

                  (not (eql predchazejici_pole2 'zed)))

             (and (not (null predchazejici_pole3))

                  (not (eql predchazejici_pole3 'zed))))

          (set_pole viditelna_mapa relativni_pozice_posunuta hodnota))

  )

)



(defmethod viditelna_mapa_rovne((mapa trida_mapa)

                                (viditelna_mapa trida_mapa)

                                (aktivni_objekt trida_aktivni_objekt)

                                (uroven integer)

                                (vektor_uroven trida_pozice)

                                (vektor_predchazejici trida_pozice))

  (let* ((relativni_pozice (make-instance 'trida_pozice

                               :x (+ (* (slot_x vektor_uroven) uroven)

                                     (slot_x vektor_uroven))

                               :y (+ (* (slot_y vektor_uroven) uroven)

                                     (slot_y vektor_uroven))))

         (relativni_pozice_posunuta

            (relativni_pozice_posunuta relativni_pozice))

         (hodnota (hodnota_mapy mapa aktivni_objekt relativni_pozice))

        )

    (cond ((eql uroven 0)

             (set_pole viditelna_mapa relativni_pozice_posunuta hodnota))

          (t (let ((predchazejici_pole (get_pole viditelna_mapa

                      (soucet relativni_pozice_posunuta 

                              vektor_predchazejici)

                  )))

               (viditelna_mapa_test viditelna_mapa

                                    relativni_pozice_posunuta

                                    hodnota predchazejici_pole)

             )

          )

    )

  )

)



(defmethod viditelna_mapa_dopredu((mapa trida_mapa)

                                  (viditelna_mapa trida_mapa)

                                  (aktivni_objekt trida_aktivni_objekt)

                                  (uroven integer))

  (viditelna_mapa_rovne mapa viditelna_mapa aktivni_objekt uroven

                        vektor_nahoru vektor_dolu)

)



(defmethod viditelna_mapa_doleva((mapa trida_mapa)

                                 (viditelna_mapa trida_mapa)

                                 (aktivni_objekt trida_aktivni_objekt)

                                 (uroven integer))

  (viditelna_mapa_rovne mapa viditelna_mapa aktivni_objekt uroven 

                        vektor_doleva vektor_doprava)

)



(defmethod viditelna_mapa_doprava((mapa trida_mapa)

                                  (viditelna_mapa trida_mapa)

                                  (aktivni_objekt trida_aktivni_objekt)

                                  (uroven integer))

  (viditelna_mapa_rovne mapa viditelna_mapa aktivni_objekt uroven

                        vektor_doprava vektor_doleva)

)



(defmethod get_pole_viditelne((viditelna_mapa trida_mapa)

                              (pozice trida_pozice))

  (cond ((eql (slot_y pozice) -1) 'cosi)

        (t (get_pole viditelna_mapa pozice))

  )

)



(defmethod viditelna_mapa_sikmo1((mapa trida_mapa)

                                 (viditelna_mapa trida_mapa)

                                 (aktivni_objekt trida_aktivni_objekt)

                                 (uroven integer)

                                 (posun integer)

                                 (vektor_posun trida_pozice)

                                 (vektor_uroven trida_pozice)

                                 (vektor_predchazejici1 trida_pozice)

                                 (vektor_predchazejici2 trida_pozice)

                                 (vektor_predchazejici3 trida_pozice))

  (let* ((relativni_pozice (make-instance 'trida_pozice

                              :x (+ (* (slot_x vektor_posun) posun)

                                    (+ (* (slot_x vektor_uroven) uroven)

                                       (slot_x vektor_uroven)

                                    ))

                              :y (+ (* (slot_y vektor_posun) posun)

                                    (+ (* (slot_y vektor_uroven) uroven)

                                       (slot_y vektor_uroven)

                                    ))))

         (relativni_pozice_posunuta

            (relativni_pozice_posunuta relativni_pozice))

         (hodnota (hodnota_mapy mapa aktivni_objekt relativni_pozice))

         (predchazejici_pole1 (get_pole_viditelne viditelna_mapa

            (make-instance 'trida_pozice

                           :x (+ (slot_x relativni_pozice_posunuta)

                                 (slot_x vektor_predchazejici1))

                           :y (+ (slot_y relativni_pozice_posunuta)

                                 (slot_y vektor_predchazejici1)))))

         (predchazejici_pole2 (get_pole_viditelne viditelna_mapa

            (make-instance 'trida_pozice

                           :x (+ (slot_x relativni_pozice_posunuta)

                                 (slot_x vektor_predchazejici2))

                           :y (+ (slot_y relativni_pozice_posunuta)

                                 (slot_y vektor_predchazejici2)))))

         (predchazejici_pole3 (get_pole_viditelne viditelna_mapa

            (make-instance 'trida_pozice

                           :x (+ (slot_x relativni_pozice_posunuta)

                                 (slot_x vektor_predchazejici3))

                           :y (+ (slot_y relativni_pozice_posunuta)

                                 (slot_y vektor_predchazejici3)))))

        )

    (cond ((test_pulkruh relativni_pozice)

      (viditelna_mapa_test2 viditelna_mapa relativni_pozice_posunuta

                            hodnota predchazejici_pole1 predchazejici_pole2

                            predchazejici_pole3))

    )

  )

)



(defmethod viditelna_mapa_sikmo2((mapa trida_mapa)

                                 (viditelna_mapa trida_mapa)

                                 (aktivni_objekt trida_aktivni_objekt)

                                 (uroven integer)

                                 (vektor_posun trida_pozice)

                                 (vektor_uroven trida_pozice)

                                 (vektor_predchazejici1 trida_pozice)

                                 (vektor_predchazejici2 trida_pozice)

                                 (vektor_predchazejici3 trida_pozice))

  (cond ((zerop uroven) nil)

        (t (mapc

             #'(lambda (posun)

               (viditelna_mapa_sikmo1 mapa viditelna_mapa

                  aktivni_objekt uroven posun vektor_posun vektor_uroven

                  vektor_predchazejici1 vektor_predchazejici2

                  vektor_predchazejici3)

             )

             (cdr (cisla (+ uroven 1)))

           )

        )

  )

)



(defmethod viditelna_mapa_sikmo_doprava((mapa trida_mapa)

                                        (viditelna_mapa trida_mapa)

                                        (aktivni_objekt trida_aktivni_objekt)

                                        (uroven integer))

  (viditelna_mapa_sikmo1 mapa viditelna_mapa aktivni_objekt uroven 0

                         vektor_stop vektor_nahoru_doprava

                         vektor_dolu_doleva vektor_dolu vektor_doleva)

)



(defmethod viditelna_mapa_doprava_dopredu((mapa trida_mapa)

                                          (viditelna_mapa trida_mapa)

                                          (aktivni_objekt trida_aktivni_objekt)

                                          (uroven integer))

  (viditelna_mapa_sikmo2 mapa viditelna_mapa aktivni_objekt uroven

                         vektor_doprava vektor_nahoru

                         vektor_dolu_doleva vektor_dolu vektor_doleva)

)



(defmethod viditelna_mapa_doprava_doprava((mapa trida_mapa)

                                          (viditelna_mapa trida_mapa)

                                          (aktivni_objekt trida_aktivni_objekt)

                                          (uroven integer))

  (viditelna_mapa_sikmo2 mapa viditelna_mapa aktivni_objekt uroven

                         vektor_nahoru vektor_doprava

                         vektor_dolu_doleva vektor_doleva vektor_dolu)

)



(defmethod viditelna_mapa_sikmo_doleva((mapa trida_mapa)

                                          (viditelna_mapa trida_mapa)

                                          (aktivni_objekt trida_aktivni_objekt)

                                          (uroven integer))

  (viditelna_mapa_sikmo1 mapa viditelna_mapa aktivni_objekt uroven 0

                         vektor_stop vektor_nahoru_doleva

                         vektor_dolu_doprava vektor_dolu vektor_doprava)

)



(defmethod viditelna_mapa_doleva_dopredu((mapa trida_mapa)

                                          (viditelna_mapa trida_mapa)

                                          (aktivni_objekt trida_aktivni_objekt)

                                          (uroven integer))

  (viditelna_mapa_sikmo2 mapa viditelna_mapa aktivni_objekt uroven

                         vektor_doleva vektor_nahoru

                         vektor_dolu_doprava vektor_dolu vektor_doprava)

)



(defmethod viditelna_mapa_doleva_doleva((mapa trida_mapa)

                                          (viditelna_mapa trida_mapa)

                                          (aktivni_objekt trida_aktivni_objekt)

                                          (uroven integer))

  (viditelna_mapa_sikmo2 mapa viditelna_mapa aktivni_objekt uroven

                         vektor_nahoru vektor_doleva

                         vektor_dolu_doprava vektor_doprava vektor_dolu)

)



(defun cisla(maximum)

  (let ((seznam (make-list maximum))

        (cislo 0)

       )

    (mapl #'(lambda (p)

           (rplaca p cislo)

           (setq cislo (+ cislo 1))

          )

          seznam

    )

  )

)



(defun cisla2(minimum maximum)

  (let ((seznam (make-list (- maximum (- minimum 1))))

        (cislo minimum)

       )

    (mapl #'(lambda (p)

           (rplaca p cislo)

           (setq cislo (+ cislo 1))

          )

          seznam

    )

  )

)



(defun prazdna_viditelna_mapa()

  (make-instance 'trida_mapa :pole

    (make-array (1+ max_viditelnost) 

                  :initial-contents 

                    (mapcar #'(lambda(p)

                                (declare (ignore p))

                                (make-array (1+ (* 2 max_viditelnost))

                                            :element-type 'symbol

                                            :initial-element nil)

                              )

                            (make-list (1+ max_viditelnost))

                    )        

    )

  )

)



;konstrukce viditelne mapy

(defmethod viditelna_mapa((mapa trida_mapa)

                          (aktivni_objekt trida_aktivni_objekt))

  (let* ((viditelna_mapa (prazdna_viditelna_mapa)))

    (set_pole viditelna_mapa 

              (make-instance 'trida_pozice :x max_viditelnost :y 0) 

              'chodba)

    (mapc #'(lambda (uroven)

            (viditelna_mapa_dopredu mapa viditelna_mapa

                                    aktivni_objekt uroven)

            (viditelna_mapa_doleva mapa viditelna_mapa

                                   aktivni_objekt uroven)

            (viditelna_mapa_doprava mapa viditelna_mapa

                                    aktivni_objekt uroven)

            (viditelna_mapa_doprava_dopredu mapa viditelna_mapa

                                            aktivni_objekt uroven)

            (viditelna_mapa_doleva_dopredu mapa viditelna_mapa

                                           aktivni_objekt uroven)

            (viditelna_mapa_doleva_doleva mapa viditelna_mapa

                                          aktivni_objekt uroven)

            (viditelna_mapa_doprava_doprava mapa viditelna_mapa

                                            aktivni_objekt uroven)

            (viditelna_mapa_sikmo_doprava mapa viditelna_mapa

                                          aktivni_objekt uroven)

            (viditelna_mapa_sikmo_doleva mapa viditelna_mapa

                                         aktivni_objekt uroven)

          )

          (cisla max_viditelnost)

    )

    viditelna_mapa

  )

)

