(in-package "BLUDISTE")

(provide "viditelne_objekty")

(require "aktivni_objekt" "aktivni_objekt")

(require "mapa" "mapa")



; --------------------------------------------------------------

; viditelnost objektu

; ===================





(defmethod test_viditelnost((postava trida_aktivni_objekt)

                            (prisera trida_aktivni_objekt)

                            (viditelna_mapa trida_mapa))

  (let* ((relativni_pozice (vytvor_relativni_pozici postava prisera))

         (souradnice (make-instance 'trida_pozice 

                         :x (+ (slot_x relativni_pozice) max_viditelnost)

                         :y (slot_y relativni_pozice)))

         (hodnota (get_pole viditelna_mapa souradnice))

        )

    (cond ((null hodnota) nil)

          ((eql hodnota 'zed) nil)

          (t t)

    )

  )

)



;test zda je prisera viditelna

(defmethod test_viditelny_objekt((postava trida_aktivni_objekt)

                                 (prisera trida_aktivni_objekt)

                                 (viditelna_mapa trida_mapa))

  (cond ((test_rovnost postava prisera) nil)

        ((not (test_rozdil postava prisera)) nil)

        ((not (test_znamenka postava prisera)) nil)

        ((not (test_viditelnost postava prisera viditelna_mapa)) nil)

        (t t)

  )

)





;viditelne postavy/prisery/strely z dane pozice

(defmethod viditelne_objekty((aktivni_objekt trida_aktivni_objekt)

                             (prisery list)

                             (viditelna_mapa trida_mapa))

  (mapcan

    #'(lambda (prisera)

        (cond ((test_viditelny_objekt aktivni_objekt 

                                      prisera viditelna_mapa)

          (cond ((typep prisera 'trida_postava)

                   (list 

                     (make-instance 'trida_postava

                      :pozice (vytvor_relativni_pozici aktivni_objekt 

                                                       prisera)

                      :smer_pohledu (otoceny_pohled aktivni_objekt 

                                                    prisera)

                      :tahovy_objekt (slot_tahovy_objekt prisera)

                      :pocet_zivotu (slot_pocet_zivotu prisera)

                      :pocet_klicu (slot_pocet_klicu prisera)

                      :pocet_strel (slot_pocet_strel prisera)

                      :pocet_bodu (slot_pocet_bodu prisera)

                     )

                   ))

                (t

                   (list 

                     (make-instance 'trida_aktivni_objekt

                      :pozice (vytvor_relativni_pozici aktivni_objekt 

                                                       prisera)

                      :smer_pohledu (otoceny_pohled aktivni_objekt 

                                                    prisera)

                      :tahovy_objekt (slot_tahovy_objekt prisera)

                      :pocet_zivotu (slot_pocet_zivotu prisera)

                     )

                   )  

                ) 

           )

        ))

      )

    prisery

  )

)





;verejne parametry postavicky, tj. co z ni se preda do tahove funkce

(defmethod viditelne_parametry_postavy((aktivni_objekt trida_aktivni_objekt))

  (cond ((typep aktivni_objekt 'trida_postava)

           (make-instance 'trida_postava

                          :pocet_zivotu (slot_pocet_zivotu aktivni_objekt)

                          :pocet_klicu (slot_pocet_klicu aktivni_objekt)

                          :pocet_strel (slot_pocet_strel aktivni_objekt)

                          :pocet_bodu (slot_pocet_bodu aktivni_objekt)

           )

        )  

        (t (make-instance 'trida_aktivni_objekt

                          :pocet_zivotu (slot_pocet_zivotu aktivni_objekt)

           )

        )   

  )

)





; preved souradnice objektu na souradnice v "(reverse viditelna_mapa)"

(defmethod posun_viditelne_objekty((prisery list))

  (mapc

    #'(lambda (prisera)

      (let* (

        (pozice (slot_pozice prisera))

        (nova_pozice (make-instance 'trida_pozice

          :x (+ (slot_x pozice) max_viditelnost)

          :y (- max_viditelnost (slot_y pozice))

      )))

      (setf (slot_pozice prisera) nova_pozice)

    ) )

    prisery

  )

  prisery

)



